var sUserAgent = navigator.userAgent;
var fAppVersion = parseFloat(navigator.appVersion);

function compareVersions(sVersion1, sVersion2) {

    var aVersion1 = sVersion1.split(".");
    var aVersion2 = sVersion2.split(".");
    
    if (aVersion1.length > aVersion2.length) {
        for (var i=0; i < aVersion1.length - aVersion2.length; i++) {
            aVersion2.push("0");
        }
    } else if (aVersion1.length < aVersion2.length) {
        for (var i=0; i < aVersion2.length - aVersion1.length; i++) {
            aVersion1.push("0");
        }    
    }
    
    for (var i=0; i < aVersion1.length; i++) {
 
        if (aVersion1[i] < aVersion2[i]) {
            return -1;
        } else if (aVersion1[i] > aVersion2[i]) {
            return 1;
        }    
    }
    
    return 0;

}

var bIsOpera = sUserAgent.indexOf("Opera") > -1;
var bIsMinOpera4 = bIsMinOpera5 = bIsMinOpera6 = bIsMinOpera7 = bIsMinOpera7_5 = false;

if (bIsOpera) {
    var fOperaVersion;
    if(navigator.appName == "Opera") {
        fOperaVersion = fAppVersion;
    } else {
        var reOperaVersion = new RegExp("Opera (\\d+\\.\\d+)");
        reOperaVersion.test(sUserAgent);
        fOperaVersion = parseFloat(RegExp["$1"]);
    }

    bIsMinOpera4 = fOperaVersion >= 4;
    bIsMinOpera5 = fOperaVersion >= 5;
    bIsMinOpera6 = fOperaVersion >= 6;
    bIsMinOpera7 = fOperaVersion >= 7;
    bIsMinOpera7_5 = fOperaVersion >= 7.5;
}

var bIsKHTML = sUserAgent.indexOf("KHTML") > -1 
              || sUserAgent.indexOf("Konqueror") > -1 
              || sUserAgent.indexOf("AppleWebKit") > -1; 
              
var bIsMinSafari1 = bIsMinSafari1_2 = false;
var bIsMinKonq2_2 = bIsMinKonq3 = bIsMinKonq3_1 = bIsMinKonq3_2 = false;

if (bIsKHTML) {
    bIsSafari = sUserAgent.indexOf("AppleWebKit") > -1;
    bIsKonq = sUserAgent.indexOf("Konqueror") > -1;

    if (bIsSafari) {
        var reAppleWebKit = new RegExp("AppleWebKit\\/(\\d+(?:\\.\\d*)?)");
        reAppleWebKit.test(sUserAgent);
        var fAppleWebKitVersion = parseFloat(RegExp["$1"]);

        bIsMinSafari1 = fAppleWebKitVersion >= 85;
        bIsMinSafari1_2 = fAppleWebKitVersion >= 124;
    } else if (bIsKonq) {

        var reKonq = new RegExp("Konqueror\\/(\\d+(?:\\.\\d+(?:\\.\\d)?)?)");
        reKonq.test(sUserAgent);
        bIsMinKonq2_2 = compareVersions(RegExp["$1"], "2.2") >= 0;
        bIsMinKonq3 = compareVersions(RegExp["$1"], "3.0") >= 0;
        bIsMinKonq3_1 = compareVersions(RegExp["$1"], "3.1") >= 0;
        bIsMinKonq3_2 = compareVersions(RegExp["$1"], "3.2") >= 0;
    } 
    
}

var bIsIE = sUserAgent.indexOf("compatible") > -1 
           && sUserAgent.indexOf("MSIE") > -1
           && !bIsOpera;
           
var bIsMinIE4 = bIsMinIE5 = bIsMinIE5_5 = bIsMinIE6 = false;

if (bIsIE) {
    var reIE = new RegExp("MSIE (\\d+\\.\\d+);");
    reIE.test(sUserAgent);
    var fIEVersion = parseFloat(RegExp["$1"]);

    bIsMinIE4 = fIEVersion >= 4;
    bIsMinIE5 = fIEVersion >= 5;
    bIsMinIE5_5 = fIEVersion >= 5.5;
    bIsMinIE6 = fIEVersion >= 6.0;
}

var bIsMoz = sUserAgent.indexOf("Gecko") > -1
            && !bIsKHTML;

var bIsMinMoz1 = bIsMinMoz1_4 = bIsMinMoz1_5 = false;

if (bIsMoz) {
    var reMoz = new RegExp("rv:(\\d+\\.\\d+(?:\\.\\d+)?)");
    reMoz.test(sUserAgent);
    bIsMinMoz1 = compareVersions(RegExp["$1"], "1.0") >= 0;
    bIsMinMoz1_4 = compareVersions(RegExp["$1"], "1.4") >= 0;
    bIsMinMoz1_5 = compareVersions(RegExp["$1"], "1.5") >= 0;
}

var bIsNS4 = !bIsIE && !bIsOpera && !bIsMoz && !bIsKHTML 
            && (sUserAgent.indexOf("Mozilla") == 0) 
            && (navigator.appName == "Netscape") 
            && (fAppVersion >= 4.0 && fAppVersion < 5.0);

var bIsMinNS4 = bIsMinNS4_5 = bIsMinNS4_7 = bIsMinNS4_8 = false;

if (bIsNS4) {
    bIsMinNS4 = true;
    bIsMinNS4_5 = fAppVersion >= 4.5;
    bIsMinNS4_7 = fAppVersion >= 4.7;
    bIsMinNS4_8 = fAppVersion >= 4.8;
}

var bIsWin = (navigator.platform == "Win32") || (navigator.platform == "Windows");
var bIsMac = (navigator.platform == "Mac68K") || (navigator.platform == "MacPPC") 
            || (navigator.platform == "Macintosh");

var bIsUnix = (navigator.platform == "X11") && !bIsWin && !bIsMac;

var bIsWin95 = bIsWin98 = bIsWinNT4 = bIsWin2K = bIsWinME = bIsWinXP = false;
var bIsMac68K = bIsMacPPC = false;
var bIsSunOS = bIsMinSunOS4 = bIsMinSunOS5 = bIsMinSunOS5_5 = false;

if (bIsWin) {
    bIsWin95 = sUserAgent.indexOf("Win95") > -1 
              || sUserAgent.indexOf("Windows 95") > -1;
    bIsWin98 = sUserAgent.indexOf("Win98") > -1 
              || sUserAgent.indexOf("Windows 98") > -1;
    bIsWinME = sUserAgent.indexOf("Win 9x 4.90") > -1 
              || sUserAgent.indexOf("Windows ME") > -1;
    bIsWin2K = sUserAgent.indexOf("Windows NT 5.0") > -1 
              || sUserAgent.indexOf("Windows 2000") > -1;
    bIsWinXP = sUserAgent.indexOf("Windows NT 5.1") > -1 
              || sUserAgent.indexOf("Windows XP") > -1;
    bIsWinNT4 = sUserAgent.indexOf("WinNT") > -1 
              || sUserAgent.indexOf("Windows NT") > -1 
              || sUserAgent.indexOf("WinNT4.0") > -1 
              || sUserAgent.indexOf("Windows NT 4.0") > -1 
              && (!bIsWinME && !bIsWin2K && !bIsWinXP);
} 

if (bIsMac) {
    bIsMac68K = sUserAgent.indexOf("Mac_68000") > -1 
               || sUserAgent.indexOf("68K") > -1;
    bIsMacPPC = sUserAgent.indexOf("Mac_PowerPC") > -1 
               || sUserAgent.indexOf("PPC") > -1;  
}

if (bIsUnix) {
    bIsSunOS = sUserAgent.indexOf("SunOS") > -1;

    if (bIsSunOS) {
        var reSunOS = new RegExp("SunOS (\\d+\\.\\d+(?:\\.\\d+)?)");
        reSunOS.test(sUserAgent);
        bIsMinSunOS4 = compareVersions(RegExp["$1"], "4.0") >= 0;
        bIsMinSunOS5 = compareVersions(RegExp["$1"], "5.0") >= 0;
        bIsMinSunOS5_5 = compareVersions(RegExp["$1"], "5.5") >= 0;
    }
}
